#include <Arduino.h>
#include <esp_now.h>
#include <WiFi.h>
  
// Motor 1 (SLAVE)
int r_en1 = 19; // +
int l_en1 = 21; // -
int r_pwm1 = 5; // +
int l_pwm1 = 22; // -

// Motor 2 (SLAVE)
int r_en2 = 2; // +
int l_en2 = 4; // -
int r_pwm2 = 16; // +
int l_pwm2 = 17; // -

void onDataRecv(const esp_now_recv_info *info, const uint8_t *incomingData, int len) {
  String Direction = "";
  for (int i = 0; i < len; i++) {
    Direction += (char)incomingData[i];

  }
  Serial.print("Received Direction: ");
  Serial.println(Direction);

  if (Direction == "F") {
    moveForward();
  } else if (Direction == "B") {
    moveBackward();
  } else if (Direction == "L") {
    moveLeft();
  } else if (Direction == "R") {
    moveRight();
  } else if (Direction == "FL") {
    moveForwardLeft();
  } else if (Direction == "FR") {
    moveForwardRight();
  } else if (Direction == "BL") {
    moveBackwardLeft();
  } else if (Direction == "BR") {
    moveBackwardRight();
  } else if (Direction == "S") {
    moveStop();
  }
}

void setup() {
  pinMode(r_en1, OUTPUT);
  pinMode(l_en1, OUTPUT);
  pinMode(r_pwm1, OUTPUT);
  pinMode(l_pwm1, OUTPUT);
  pinMode(r_en2, OUTPUT);
  pinMode(l_en2, OUTPUT);
  pinMode(r_pwm2, OUTPUT);
  pinMode(l_pwm2, OUTPUT);

  Serial.begin(115200);

  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }
  esp_now_register_recv_cb(onDataRecv);
}

void loop() {

}

void moveForward() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 255);
  analogWrite(l_pwm1, 0);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 255);
  analogWrite(l_pwm2, 0);
}

void moveBackward() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 0);
  analogWrite(l_pwm1, 255);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 0);
  analogWrite(l_pwm2, 255);
}

void moveLeft() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 0);
  analogWrite(l_pwm1, 255);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 255);
  analogWrite(l_pwm2, 0);
}

void moveRight() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 255);
  analogWrite(l_pwm1, 0);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 0);
  analogWrite(l_pwm2, 255);
}

void moveForwardLeft() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 0);
  analogWrite(l_pwm1, 0);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 255);
  analogWrite(l_pwm2, 0);
}

void moveForwardRight() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 255);
  analogWrite(l_pwm1, 0);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 0);
  analogWrite(l_pwm2, 0);
}

void moveBackwardLeft() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 0);
  analogWrite(l_pwm1, 255);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 0);
  analogWrite(l_pwm2, 0);
}

void moveBackwardRight() {

  digitalWrite(r_en1, HIGH);
  digitalWrite(l_en1, HIGH);
  analogWrite(r_pwm1, 0);
  analogWrite(l_pwm1, 0);
  digitalWrite(r_en2, HIGH);
  digitalWrite(l_en2, HIGH);
  analogWrite(r_pwm2, 0);
  analogWrite(l_pwm2, 255);
}

void moveStop() {

  digitalWrite(r_en1, LOW);
  digitalWrite(l_en1, LOW);
  analogWrite(r_pwm1, 0);
  analogWrite(l_pwm1, 0);
  digitalWrite(r_en2, LOW);
  digitalWrite(l_en2, LOW);
  analogWrite(r_pwm2, 0);
  analogWrite(l_pwm2, 0);
}